/**
 * Copyright (c) 2024 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "mainmenu.h"
#include "game/game.h"

menu_t MAIN_MENU;

void mainMenuInit() {
  const char_t* strings[] = {
    "New Game",
    "Load Game",
    "Options",
    "Exit"
  };

  uint16_t columns = 1;
  uint16_t rows = 4;
  menuInit(&MAIN_MENU, columns, rows);
  memcpy(MAIN_MENU.strings, strings, sizeof(strings));
  MAIN_MENU.selectCallback = mainMenuSelectCallback;
}

void mainMenuUpdate() {
  menuUpdate(&MAIN_MENU);
}

void mainMenuSelectCallback(
  const menu_t *menu,
  const uint16_t x,
  const uint16_t y,
  const char_t *str
) {
  if(strcmp(str, "New Game") == 0) {
    GAME.mapNext = MAP_LIST_TEST;
    GAME.state = GAME_STATE_MAP_CHANGE;
    return;
  }

  if(strcmp(str, "Load Game") == 0) {
    return;
  }

  if(strcmp(str, "Options") == 0) {
    return;
  }

  if(strcmp(str, "Exit") == 0) {
    GAME.shouldExit = true;
    return;
  }
}